{% extends 'base.njk' %}{% block title %}BCHN Technical Bulletin 2022-05-16{% endblock %}{% block description %}{% endblock %}{% block body %}
<section class="bg-dark">
    <div class="container">
        <div class="row pb-3">
            <div class="col my-5 py-5 text-center">
                <h1 class="text-white">BCHN Technical Bulletin 2022-05-16</h1> 
            </div>
        </div>
    </div>
</section>
<section class="bg-light">
    <div class="container py-6">
        <div class="row justify-content-center">
            <article class="col-md-10 col-lg-8">
                <div class="d-flex align-items-center pb-5">
                    <img src="/static/img/logomark.svg" alt="Logo" class="mr-3 w-auto" height="40">
                    <div>
                        <div>by <strong>matricz</strong>
                        </div>
                        <div class="text-small text-muted">16 May 2022</div>
                    </div>
                </div>
                <div class="content">
                    <p>

                    </p>
                    <h1 id="bitcoin-cash-node-technical-bulletin">Bitcoin Cash Node Technical Bulletin</h1>
                    <h3 id="bchn-network-architecture">BCHN Network Architecture</h3>
                    <h4 id="summary">Summary</h4>
                    <ol>
                        <li>Introduction and rationale</li>
                        <li>The general architecture</li>
                        <li><code class="language-javascript">CConnman</code>'s threads</li>
                        <li>Benefits and impact</li>
                        <li>Appendix: Description of relevant classes and files</li>
                    </ol>
                    <hr>
                    <h4 id="introduction-and-rationale">Introduction and rationale</h4>
                    <p>The aim of this technical bulletin is to describe the current inner workings of the network management of the Bitcoin Cash Node software. The targeted audience are developers related to the Bitcoin Cash Node software project.</p>
                    <p>Bitcoin Cash is a peer to peer network, so the network code is very important both from a functional and security viewpoint.</p>
                    <p>The current incarnation of the network code (as of v24.0.0) is based on the general architecture set by the original Satoshi code in Bitcoin v0.1.0/v0.1.3 (<a href="https://satoshi.nakamotoinstitute.org/code/">Reference</a>).</p>
                    <p>The rationale for this documentation is the assessment of the benefits and impact of changing the general architecture with one that is more parallel (wrt peer communication). In the current implementation, the receiving network thread
                        "commands" the rest of the application; moreover, only one incoming message at a time can be processed. Re-engineering this part of the application can have important performance improvements. No specific recommendations will be
                        proposed in this report.</p>
                    <p>All of the following is based on BCHN v24.0.0 (at <code class="language-javascript">1ef932b1b7</code>).</p>
                    <h4 id="the-general-architecture">The general architecture</h4>
                    <p>The application has a globally scoped <code class="language-javascript">std::unique_ptr&lt;CConnman&gt; g_connman</code> which, besides managing connections, as the name suggests, manages most of the aspects of networking. It is started
                        as the last step of initialization, after all other subsystems have are running. In doing so, the initialization thread essentially passes the control of the application to the network threads.</p>
                    <p>A <code class="language-javascript">CNode</code> represents a node/peer, and it contains all of the information regarding the connection to that peer, including current network-level data buffers and application-level network <code class="language-javascript">CNetMessage</code>s.
                        <code
                        class="language-javascript">g_connman</code>maintains a vector of <code class="language-javascript">CNode</code>s/connected peers.</p>
                    <p><code class="language-javascript">Start</code>ing the <code class="language-javascript">CConnman</code> will start the following threads:</p>
                    <ul>
                        <li><code class="language-javascript">net</code> running the <code class="language-javascript">ThreadSocketHandler</code> function, which is responsible for net sockets reading and writing of messages.</li>
                        <li><code class="language-javascript">msghand</code> running <code class="language-javascript">ThreadMessageHandler</code> which handles messages received from peers.</li>
                        <li><code class="language-javascript">addcon</code> running <code class="language-javascript">ThreadOpenAddedConnections</code> and <code class="language-javascript">opencon</code> running <code class="language-javascript">ThreadOpenConnections</code> which
                            manage connections to manually-added and network-announced peers.</li>
                    </ul>
                    <p>There is a level of decoupling here in that the <code class="language-javascript">net</code> thread writes to the <code class="language-javascript">CNode</code>s' <code class="language-javascript">vProcessMsg</code> message list and reads
                        from the <code class="language-javascript">CNode</code>s' <code class="language-javascript">vSendMsg</code> message deque, while the <code class="language-javascript">msghand</code> thread does the contrary, and they work in parallel.
                        One is a list and the other is a deque because of API requirements (specifically, deque lacks <code class="language-javascript">splice()</code> used in the code).</p>
                    <h4 id="-cconnman-s-threads"><code class="language-javascript">CConnman</code>'s threads</h4>
                    <p>The <code class="language-javascript">net</code> thread is a straightforward read/write loop for network sockets and for each iteration it:</p>
                    <ol>
                        <li>Does some initializations</li>
                        <li>Marks each node/peer as "selected for receiving", "selected for sending" or neither</li>
                        <li>Accepts connections from new nodes/peers, if any</li>
                        <li>Makes a copy of the <code class="language-javascript">vNodes</code> vector (to avoid concurrency issues and release locks quickly); for each node in the copied vector
                            <ol>
                                <li>if it was set for receiving, receive data and possibly transform it into <code class="language-javascript">CNetMessage</code>s; add them to <code class="language-javascript">vProcessMsg</code> (the node's list of messages
                                    to be processed). Also <code class="language-javascript">WakeMessageHandler</code>.</li>
                                <li>otherwise, if it was set for sending, <code class="language-javascript">SocketSendData</code>
                                </li>
                                <li>an <code class="language-javascript">InactivityCheck</code> is done for the node/peer</li>
                            </ol>
                        </li>
                    </ol>
                    <hr>
                    <p>The <code class="language-javascript">msghand</code> thread is a loop for application-level messages and it:</p>
                    <ol>
                        <li>Makes a copy of the <code class="language-javascript">vNodes</code> vector; for each node in the copied vector
                            <ol>
                                <li>processes a single message from the incoming <code class="language-javascript">vProcessMsg</code> list, if any (via <code class="language-javascript">ProcessMessages</code>). Processing a message will often have the effect
                                    of sending some messages - for example when we recieve a <code class="language-javascript">GETDATA</code>, we'll end up enqueing the requested data in this <code class="language-javascript">CNode</code>'s <code class="language-javascript">vSendMsg</code> (via
                                    <code
                                    class="language-javascript">CConnman::PushMessage</code>). If any of the <code class="language-javascript">CNode</code>s has any more messages in <code class="language-javascript">vProcessMsg</code> then the <code class="language-javascript">fMoreWork</code> flag
                                        will be set to true.</li>
                                <li>does a <code class="language-javascript">SendMessages</code>; this will maintain connection with the peer via <code class="language-javascript">ping/pong</code>, exchange recent peers, manage IBD (?), send <code class="language-javascript">inv</code>entories
                                    for recent blocks and transactions, send <code class="language-javascript">getdata</code> for transactions we're missing, and some other housekeeping regarding this <code class="language-javascript">CNode</code>
                                </li>
                            </ol>
                        </li>
                        <li>If <code class="language-javascript">fMoreWork</code> has been set by any of the <code class="language-javascript">CNode</code>s, the whole loop is repeated immediately; else it waits for the closest Poisson delay of the <code class="language-javascript">CNode</code>s'
                            <code
                            class="language-javascript">nNextInvSend</code>and repeats. Optionally, this thread can be woken up for processing with <code class="language-javascript">WakeMessageHandler</code> (used by the <code class="language-javascript">net</code> thread loop).</li>
                    </ol>
                    <p>The <code class="language-javascript">PeerLogicValidation::ProcessMessages</code> and <code class="language-javascript">ProcessMessage</code> functions are really complex. They have a big part of the p2p functionality and application logic.</p>
                    <p>Each <code class="language-javascript">CNode</code> has a Poisson delay set for sending <code class="language-javascript">inv</code>s to it. When this delay expires for one node, all of the nodes will be processed again.</p>
                    <hr>
                    <p>The <code class="language-javascript">addcon</code> thread opens connections to peers specified with the <code class="language-javascript">addnode</code> command line parameter and RPC command. <a href="https://docs.bitcoincashnode.org/doc/json-rpc/addnode/">Nodes added using addnode (or -connect) are protected from DoS disconnection and are not required to be full nodes as other outbound peers are</a>.</p>
                    <p>The <code class="language-javascript">opencon</code> thread will do two different things if the <code class="language-javascript">-connect</code> parameter is specified. If it's specified, it will enter a loop that will connect to the
                        specified IPs, and any further IPs specified with the <code class="language-javascript">addnode</code> RPC command; exiting the loop will terminate the thread. Otherwise, it will enter into "normal operation" mode, which has an outer
                        loop which finds seed nodes, calculates nodes to try, and an inner loop that will find one valid connectable address; after that, the outer loop will finish with a connection attempt to that address.</p>
                    <h4 id="benefits-and-impact">Benefits and impact</h4>
                    <p>The <code class="language-javascript">net</code> and <code class="language-javascript">msghand</code> threads work in parallel, neatly separating the processing of network-level streams and application-level messages. Looking at the details
                        of the <code class="language-javascript">msghand</code> thread, it is evident that the processing of received messages is essentially single-threaded. This includes mempool admissions of transactions, block validation, or the ability
                        to serve simple peer queries (e.g., GETDATA) while the processing of another message is running.</p>
                    <p>The benefits could possibly be:</p>
                    <ul>
                        <li>A great increase in transaction admission rate. The longest steps of transaction admission are UTXO lookups (IO bound) and signature verification (CPU bound) - if they could be done in parallel (while the actual mempool data structure
                            admission remained single-threaded), then the admission could scale out linearly on multicore CPUs, up until other limits are hit (mempool checks and inserts, ...). This cannot be done if only one single message (a TX in this
                            case) can be processed.</li>
                        <li>The ability to process blocks in parallel. Currently, if two blocks arrive in short order, one cannot be processed until the other has finished processing. There are tradeoffs to be made here, it's a functionality that might be
                            useful (for example if I receive one big and then one smaller block, I'd might like to start mining on the smaller right away).</li>
                        <li>The ability to serve simple peer and RPC requests even while some heavy processing is being done. Currently, if a peer asks for INVs, HEADERS or GETDATA, they cannot be satisfied if the processing of a big block is happening. There
                            is no other technical reason for this though, and while it could put a small load on top of my block processing, it would optimize the network as a whole. This is a concrete bottleneck to network propagation in schemes like
                            CompactBlocks.</li>
                    </ul>
                    <p>bitcoind is a peer-to-peer application, so the network processing is central to both functionality and security. Reworking the architecture of these central aspects comes with a set of costs and risks:</p>
                    <ul>
                        <li>The functionality needs to be either preserved or, where changes are made, they need to be accurately documented. Looking at the <code class="language-javascript">msghand</code> loop, which works in strange ways, this could be difficult
                            and nuanced. Would a different ordering of processing affect the functionality?</li>
                        <li>The security needs to be preserved. In particular, all known DoS vectors need to be guarded for. This includes all of the explicitly implemented DoS protections, as well as some that could arise from changing the architecture (for
                            example, currently, all peers' messages will be processed on every loop, so no one peer can "overwhelm" the others in my queues).</li>
                    </ul>
                    <p>Depending on how we want to go about it, all known and anticipated DoS vectors would need to be protected from with either:</p>
                    <ul>
                        <li>Manual verification of the code, while it changes; cheaper but more error prone.</li>
                        <li>Automated verification via encoded tests; possibly more reliable but worth much more initial effort.</li>
                    </ul>
                    <p>There is always the possibility of introduction of a DoS vector that is both unknown and unanticipated, though.</p>
                    <p>Moreover, there is always the possibility of introducing programming errors, especially in a big refactor. There are precedents for this, and the reputation hits this could lead to are quite important. This is very important, especially
                        while the Bitcoin Cash Node software remains, to the best of my knowledge, the main node used for mining, and needs to be rock-solid reliable as it has always been.</p>
                    <p>There is distinct but related architectural concern that will also need to be addressed to fully take advantage of an architectural rework: fine-grained locking. The <code class="language-javascript">net</code> part of the current implementation
                        relays on a multitude of fine locks for synchronization; on the other hand, the <code class="language-javascript">msghand</code>/processing part grossly uses a single big lock (<code class="language-javascript">cs_main</code>) most
                        of the time. Even if we do parallelize the message processing, we would see little benefit without also implementing finer grained locks around it. The impact of doing so is out of the scope of the current report.</p>
                    <h4 id="appendix-description-of-relevant-classes-and-files">Appendix: Description of relevant classes and files</h4>
                    <p><em>In the following <code class="language-javascript">is a</code> strictly signifies that a class extends another. <code class="language-javascript">has a</code> strictly signifies composition.</em>
                    </p>
                    <p>A <code class="language-javascript">CNetAddr</code> (in netaddress.h) represents a network address (IPv6, or IPv4 using mapped IPv6 range (::FFFF:0:0/96)).</p>
                    <p>A <code class="language-javascript">CService</code> (in netaddress.h) <em>is a</em>  <code class="language-javascript">CNetAddr</code> that also has a (TCP) port.</p>
                    <p>A <code class="language-javascript">CAddress</code> (in protocol.h) <em>is a</em>  <code class="language-javascript">CService</code> "with information about it as peer" (i.e. <code class="language-javascript">ServiceFlags</code>).</p>
                    <p>A <code class="language-javascript">CAddrInfo</code> (in addrman.h) <em>is a</em>  <code class="language-javascript">CAddress</code> with "extended statistics". It is serializable and managed by <code class="language-javascript">CAddrMan</code> (in
                        addrman.h) which, among other things, is what reads and writes to the peers.dat file (via <code class="language-javascript">CAddrDB</code>).</p>
                    <p>A <code class="language-javascript">CSubNet</code> (in netaddress.h) <em>has a</em>  <code class="language-javascript">CNetAddr</code> and a <code class="language-javascript">netmask</code>. It's used by the <code class="language-javascript">BanMan</code> (in
                        banman.h), via <code class="language-javascript">CBanDB</code>, and also other parts of the application, like the http server</p>
                    <p>The <code class="language-javascript">netbase.h</code> file has a number of functions for basic networking.</p>
                    <p>A <code class="language-javascript">NetEventsInterface</code> (in net_processing.h) is an "interface for message handling". The <code class="language-javascript">PeerLogicValidation</code>, the class that does most of the network processing
                        (in net_processing.cpp) <em>is a</em>  <code class="language-javascript">NetEventsInterface</code> (and also <em>is a</em>  <code class="language-javascript">CValidationInterface</code>); it is the only class that implements this interface.</p>
                    <p>A <code class="language-javascript">CNetMessage</code> (in net.h) contains partial or complete messages. While data is being received, the message can be left partial, until the next read. A complete message <em>has a</em>  <code class="language-javascript">CMessageHeader</code> and
                        the <code class="language-javascript">CDataStream</code>.</p>
                    <p>A <code class="language-javascript">CNode</code> (in net.h) represents information about a network peer. It <em>has a</em>  <code class="language-javascript">CAddress</code> and data structures for exchange of messages and raw data.</p>
                    <p>A <code class="language-javascript">CConnman</code> (in net.h) manages the connections to peers. It <em>has a</em> vector of <code class="language-javascript">CNode</code> pointers, and methods to connect, disconnect and otherwise manage
                        connections and peers.</p>
                    <p>
                        <img src="/static/img/newsroom/2022-05-16/2022-05-16_network_architecture_description_net_EN.png" class="rounded img-fluid">
                    </p>
                    <p>The above image presents the relevant classes and their interactions. The most important are figured in pink.</p>
                    <hr>
                    <p>Links:</p>
                    <ul>
                        <li>Repository link of this announcement: <a href="https://gitlab.com/bitcoin-cash-node/announcements/-/blob/master/2022-05-16_network_architecture_description_EN.md">GitLab</a>
                        </li>
                    </ul>
                </div>
            </article>
        </div>
    </div>
</section>
{% endblock %}
